Feature # 26665 (Resolved): Fluid: Implement String comparison
Author: Peter Niederlag Category: Core
Created: 2010-03-10 Assigned To:
Updated: 2012-08-11 Due date:
Has patch: No
Subject: support literal strings in boolean arguments
Description

the 'if' viewhelper should support comparison on strings.

This can easily be fixed by adding [a-zA-Z] on $booleanExpressionTextNodeCheckerRegularExpression in
Core/Parser/SyntaxTree/ViewHelperNode.php, see attached patch. if works like a charm with this patch.

However I fear, something else probably breaks badly?

Related issues:
related to TYPO3.Fluid - Feature # 5485: Missing operators "===", "!==" and "... Rejected 2009-11-24
duplicated by TYPO3.Fluid - Bug # 7039: if ViewHelper: conditions always true Rejected 2010-03-28

Associated revisions
Revision 125413ca - 2012-08-10 10:33 - Alexander Berl

[TASK] Support literal strings in boolean arguments

This change adds support for string literals in boolean comparisons.
String literals have to be surrounded by single or double quotes and
may contain escaped single or double quotes.

Change-Id: I8f1a0bf5a36404f9747ac1d8261e4e88b3c9e8a5
Resolves: #6757
Releases: 1.2

History
#1 - 2010-06-18 15:09 - Sebastian Kurfuerst
- Project changed from Extbase MVC Framework to TYPO3.Fluid

#2 - 2010-06-24 20:10 - Sebastian Kurfuerst

note to myself: we need proper selenium tests for the if ViewHelper.

After thinking about this right now, I think this could actually work. I always thought that the above clashes with the object accessor syntax like {..}, but
as they are clearly identified by the braces, there should not be any problem.

So, after proper testing and test coverage, I think this could work out.

Greets,
Sebastian
#3 - 2010-06-25 16:04 - Bastian Waidelich
- Category set to Core
- Status changed from New to Accepted
- Assigned To set to Bastian Waidelich
- Branch set to v4 + v5

#4 - 2010-06-27 13:46 - Bastian Waidelich
- Subject changed from VieHelper if : support literal strings to support literal strings in boolean arguments

#5 - 2010-07-12 17:23 - Christopher Hlubek

+1 for implementing that from me. I would like string literals surrounded by single quotes better.

#6 - 2010-12-17 16:40 - Karsten Dambekalns

+1, I am amazed this isn't possible: <f:if condition="{foo} !== 'bar'"><f:then> ...

#7 - 2010-12-30 18:21 - Bastian Waidelich
- Assigned To deleted (Bastian Waidelich)

#8 - 2011-05-06 10:24 - Sebastian Kurfuerst
- Tracker changed from Bug to Story
- Priority changed from Should have to Must have
- Target version set to 1.0 beta 1

#9 - 2011-05-06 11:03 - Sebastian Kurfuerst
- Tracker changed from Story to Feature

#10 - 2011-05-06 11:19 - Sebastian Kurfuerst
- Parent task set to #26665
- Has patch set to No

#11 - 2011-08-04 08:22 - Sebastian Kurfuerst
- Priority changed from Must have to Should have
- Target version changed from 1.0 beta 1 to 1230

#12 - 2011-10-20 01:42 - Karsten Dambekalns
- Target version deleted (1230)

#13 - 2012-08-02 01:09 - Gerrit Code Review
- Status changed from Accepted to Under Review

Patch set 1 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/13421

#14 - 2012-08-02 01:34 - Alexander Berl

I just took the initial idea further and required string literals to be written in single quotes.
This is necessary for allowing white spaces in the strings.
I also added basic unit tests for this behaviour and all other unit tests still pass.
It also works nicely in an extbase project so far, but a functional test probably won't hurt, I just couldn't get functional tests running in Zend Studio yet.

However there are still some questions that I'd like feedback on:

1) Should double quotes also be allowed? IMO it's probably problematic anyway, since boolean expressions are mostly used in viewhelper attributes,
which are (double) quoted normally, so the double quotes would have to be escaped. On the other hand, it is standard behaviour to be able to quote
with both single and double quotes in most programming languages.

2) What about comparison of string literals against constant numbers? Since the numbers are parsed as string numerics, the comparator compares
two strings which will never be equal unless you compare for example '5' == 5.
Also 'string' == 0 will resolve to TRUE in PHP, while with the current solution this will resolve to FALSE, so this might be unexpected behaviour.
This could be solved by casting unquoted numerics to float/int, but I'm not sure how it would work for comparison with variables holding numbers.

#15 - 2012-08-04 18:12 - Gerrit Code Review

Patch set 2 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/13421

#16 - 2012-08-07 01:32 - Gerrit Code Review

Patch set 3 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/13421

#17 - 2012-08-10 00:27 - Alexander Berl

Ok, so after quite some fiddling with this and the Viewhelpertest package, I come to the following conclusions:

1) proper string -> number comparison is definitely a must have, since else the boolean node behaves differently when comparing a string to a
constant number than comparing a string to variable with a constant number value, ie.
('foo' == 1) !== ('foo' == {constantOne})
and this is a no-go IMO (and also leads to un-green-able Viewhelpertest).

2) adding string -> number comparison is not simply achieved by casting the text node, as the input must always be cast on evaluation (text nodes may
only be created from strings), but there the distinguishing information of numeric string ("{'foo' == '0'}") or numeric literal ("{'foo' == 0}") is lost, since
quotes are stripped beforehand in the boolean node.
Hence, the introduction of a NumericNode (or NumberNode?) is needed.

I will push a changeset shortly.

#18 - 2012-08-10 01:24 - Gerrit Code Review

Patch set 4 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/13421

#19 - 2012-08-10 01:24 - Gerrit Code Review

Patch set 4 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/13421

#20 - 2012-08-10 01:33 - Gerrit Code Review

Patch set 5 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/13421

#21 - 2012-08-10 01:49 - Gerrit Code Review

Patch set 1 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/13554

#22 - 2012-08-10 01:55 - Gerrit Code Review

Patch set 1 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/13555

#23 - 2012-08-10 10:35 - Gerrit Code Review

Patch set 6 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/13421

#24 - 2012-08-11 17:35 - Alexander Berl
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:125413ca638696bb4eef9b5c26eceed51acdcf4e.

Files
fluid-if-viewhelper.diff 617 Bytes 2010-03-10 Peter Niederlag
